Subject: Re: [PATCH] git-prompt.sh: shorter equal upstream branch name

From: Julien Carsique <[email-masked]>
Date: Tue, 07 Oct 2014 17:57:23 +0200

Hi,

Thank you both for your feedback!
I'm looking at applying your requests:
- add tests,
- variable renaming,
- use of local,
- fix multiple issues on string parsing
- avoid useless bash-isms? Did you agree on the ones I should remove?

I'll send an updated patch asap. Tell me if I forgot something.

Regards,
Julien

On 01/10/2014 19:49, Junio C Hamano wrote:
> Richard Hansen <[email-masked]> writes:
>
>>> and there is no hope to "fix" them to stick to
>>> the bare-minimum POSIX,
>> I don't think it'd be hard to convert it to pure POSIX if there was a
>> desire to do so.
> Not necessarily; if you make it so slow to be usable as a prompt
> script, that is not a "conversion".  Bash-isms in the script is
> allowed for a reason, unfortunately.
>
>> It would be unwise to go to great lengths to avoid Bashisms, but I think
>> it would be smart to use POSIX syntax when it is easy to do so.  
> In general, I agree with you. People who know only bash tend to
> overuse bash-isms where they are not necessary, leaving an
> unreadable mess.
>
> For the specific purpose of Julien's "if the tail part of this
> string matches the other string, replace that with an equal sign",
> ${parameter/pattern/string} is a wrong bash-ism to use.  But the
> right solution to count the length of the other string and take a
> substring of this string from its beginning would require other
> bash-isms ${#parameter} and ${parameter:offset:length}.
>
> And that's fine.